package othello.view;

import java.awt.Component;
import java.awt.Point;

import othello.model.GameConstants;
import othello.model.Pair;
/**
 * <p>Title: Othello</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Memorial University</p>
 * @author Theodore Norvell
 * @version 1.0
 */

public class BirdsEyeViewStrategy implements GameConstants, ViewStrategy{
	
    public Point worldToView( double width, double height, double row, double col ) {
        double margin = 2.0 ;
        double vertStretch = height / (2*margin+ROWS) ;
        double horStretch = width / (2*margin+COLS) ;
        horStretch = vertStretch = Math.min( horStretch, vertStretch ) ;
        int y = (int)( (margin+row)*vertStretch ) ;
        int x = (int)( (margin+col)*horStretch ) ;
        return new Point( x, y ) ; }
    
    public Pair viewToWorld( double width, double height, double x, double y ) {
    	double margin = 2.0 ;
    	double vertStretch = height / (2*margin+ROWS) ;
    	double horStretch = width / (2*margin+COLS) ;
    	horStretch = vertStretch = Math.min( horStretch, vertStretch ) ;
    
    	int row = (int) (y/vertStretch - margin) ;
    	int col = (int) (x/horStretch - margin) ;
    	return new Pair( row, col) ;
    }
}